// nitraDlg.cpp : implementation file
//

#include "stdafx.h"
#include "nitra.h"
#include "nitraDlg.h"
#include "comdef.h"
#include "shellOpenFolder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	WM_ICON_NOTIFY			WM_USER + 1011
#define	WM_START_DOWNLOAD		WM_USER + 1112

#define TRAYTOOLTIP				_T("NItra - Your Intranet Downloader")

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_szKernel;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_szKernel = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_Kernel, m_szKernel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNitraDlg dialog

CNitraDlg::CNitraDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNitraDlg::IDD, pParent), m_taskList(m_dl.queue)
{
	//{{AFX_DATA_INIT(CNitraDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME_SMALL);
}

void CNitraDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNitraDlg)
	DDX_Control(pDX, IDC_LIST, m_taskList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNitraDlg, CDialog)
	//{{AFX_MSG_MAP(CNitraDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_TASK_RESUME, OnMenuTaskResume)
	ON_COMMAND(ID_TASK_DELETE, OnMenuTaskDelete)
	ON_COMMAND(ID_TASK_PAUSE, OnMenuTaskPause)
	ON_COMMAND(ID_TASK_STOP, OnMenuTaskStop)
	ON_COMMAND(ID_TASK_OPEN, OnMenuTaskOpen)
	ON_COMMAND(ID_TASK_OPENFOLDER, OnMenuTaskOpenFolder)
	ON_COMMAND(ID_TASK_DESTFOLDER, OnMenuTaskOpenDestFolder)
	ON_NOTIFY(NM_RCLICK, IDC_LIST, OnRclickList)
	ON_WM_CLOSE()
	ON_WM_NCPAINT()
	ON_COMMAND(ID_OPTIONS, OnOptions)
	ON_COMMAND(ID_ADD_TASK, OnAddNewTasks)
	ON_COMMAND(ID_ADD_TASKS_FOLDER, OnAddNewTasksFolder)
	ON_WM_SHOWWINDOW()
	ON_WM_ACTIVATE()
	ON_WM_WINDOWPOSCHANGING()
	ON_WM_TIMER()
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_START_DOWNLOAD, OnPostStartDownload)

	ON_COMMAND(ID_POPUP_SHOW, OnPopupShow)
	ON_COMMAND(ID_POPUP_ABOUT, OnPopupAbout)
	ON_COMMAND(ID_POPUP_EXIT, OnPopupExit)

	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipText)
	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNitraDlg message handlers

BOOL CNitraDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//    
	// 
	//
	//   
	//
	LONG xPos = -1, yPos = -1, iWidth = -1, iHeight = -1;

	reg.GetUserEntry(REG_APP, REG_POSX, xPos);
	reg.GetUserEntry(REG_APP, REG_POSY, yPos);
	reg.GetUserEntry(REG_APP, REG_WIDTH, iWidth);
	reg.GetUserEntry(REG_APP, REG_HEIGHT, iHeight);

	if(xPos >= 0 && yPos >= 0 && iWidth >= 0 && iHeight >= 0)
	{
		SetWindowPos(&wndTop, xPos, yPos, iWidth, iHeight, 0);
	}

	//   
	//
	CString keyName; LONG lWidth;

	for(int i = 0; i < 6; i++)
	{
		keyName.Format("Column %d", i);

		lWidth = 0;

		reg.GetUserEntry(REG_APP, keyName, lWidth);

		if(lWidth) {
			m_taskList.SetColumnWidth(i, lWidth);
		}
	}

	m_taskList.InsertColumn(0, "file name", LVCFMT_LEFT, 143);
	m_taskList.InsertColumn(1, "progress", LVCFMT_LEFT, 150);
	m_taskList.InsertColumn(2, "speed", LVCFMT_LEFT, 70);
	m_taskList.InsertColumn(3, "total", LVCFMT_LEFT, 150);
	m_taskList.InsertColumn(4, "source", LVCFMT_LEFT, 150);
	m_taskList.InsertColumn(5, "destination", LVCFMT_LEFT, 150);

	m_taskList.SetBkColor(RGB(255, 255, 240));

	// Add the ToolBar.
	if (!m_wndToolBar.CreateEx( this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | 
			CBRS_TOP | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_TOOLBAR_MAIN) )
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetHeight(24);

	// We need to resize the dialog to make room for control bars.
	// First, figure out how big the control bars are.
	CRect rcClientStart;
	CRect rcClientNow;
	GetClientRect(rcClientStart);
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 
				   0, reposQuery, rcClientNow);
	
	// Now move all the controls so they are in the same relative
	// position within the remaining client area as they would be
	// with no control bars.
	CPoint ptOffset(rcClientNow.left - rcClientStart.left,
					rcClientNow.top - rcClientStart.top - 17); 

	CRect  rcChild;					
	CWnd* pwndChild = GetWindow(GW_CHILD);
	while (pwndChild)
	{                               
		pwndChild->GetWindowRect(rcChild);
		ScreenToClient(rcChild);
		rcChild.OffsetRect(ptOffset);
		pwndChild->MoveWindow(rcChild, FALSE);
		pwndChild = pwndChild->GetNextWindow();
	}

	// Adjust the dialog window dimensions
	CRect rcWindow;
	GetWindowRect(rcWindow);
	rcWindow.right += rcClientStart.Width() - rcClientNow.Width();
	rcWindow.bottom += rcClientStart.Height() - rcClientNow.Height() - 17;
	MoveWindow(rcWindow, FALSE);
	
	// And position the control bars
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

	m_wndToolBar.SetWindowPos(&wndTop, 7, -2, 0, 0, SWP_NOZORDER | SWP_NOSIZE);

	//  Tray 
	//
	if (!m_TrayIcon.Create(NULL,                            // Parent window
                           WM_ICON_NOTIFY,                  // Icon notify message to use
                           DescribeState(),						 // tooltip
                           AfxGetApp()->LoadIcon(IDI_TRAY2),  // Icon to use
                           IDR_POPUP_MENU))                 // ID of tray icon
		return -1;

    m_TrayIcon.SetMenuDefaultItem(0, TRUE);

	SetTimer(0, 2000, NULL);

	//   
	//
	loadOptions();

	//  
	//
	m_dl.loadTasks();

	//  ,    
	//
	addTasks(parms.m_tasks, parms.downloadPath);

	UpdateData(false);

	//  
	//
	PostMessage(WM_START_DOWNLOAD);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

long CNitraDlg::OnPostStartDownload(WPARAM wParm, LPARAM lParm)
{
	m_dl.startDownload();

	return 1;
}

void CNitraDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		OnPopupAbout();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNitraDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
	}
	else
	{
		CDialog::OnPaint();
//		CPaintDC dc(this); // device context for painting
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNitraDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNitraDlg::onStartDownload() 
{
	m_taskList.DeleteAllItems();

	int iIndex;

	for(int i = 0; i < m_dl.queue.size(); i++)
	{
		iIndex = m_taskList.InsertItem(i, m_dl.queue[i].displayName);

//		m_taskList.SetItemText(iIndex, 4, m_dl.queue[i].sourcePath);
//		m_taskList.SetItemText(iIndex, 5, m_dl.queue[i].downloadPath);
	}
}

void CNitraDlg::onTaskStart(int nTask, CIntraTask &task)
{
	if(nTask >= m_taskList.GetItemCount()) {
		int iIndex = m_taskList.InsertItem(nTask, task.displayName);

//		m_taskList.SetItemText(iIndex, 4, task.sourcePath);
//		m_taskList.SetItemText(iIndex, 5, task.downloadPath);
	}

	onTaskProcess(nTask, task);
}

void CNitraDlg::onTaskProcess(int nTask, CIntraTask &task)
{
	m_taskList.RedrawItems(nTask, nTask);

	m_TrayIcon.SetTooltipText(DescribeState());
}

void CNitraDlg::onTaskPaused(int nTask)
{
	//m_taskList.RedrawItems(nTask, nTask);
	m_taskList.RedrawWindow();

	m_TrayIcon.SetTooltipText(DescribeState());
}

void CNitraDlg::onTaskComplete(int nTask)
{
	m_taskList.RedrawItems(nTask, nTask);

	m_TrayIcon.SetTooltipText(DescribeState());
}

void CNitraDlg::onTaskDelete(int nTask)
{
	m_taskList.DeleteItem(nTask);

	m_TrayIcon.SetTooltipText(DescribeState());
}

bool CNitraDlg::continueOnError(int errorCode)
{
	switch(errorCode)
	{
	case N_ERROR_DOWNLOADFOLDER:
		AfxMessageBox("You need to set up a default download folder !\n\n"
					  "Open the options dialog and select the folder.", MB_ICONWARNING);

		return false;
	}

	return true;
}

BOOL CNitraDlg::DestroyWindow() 
{
	return CDialog::DestroyWindow();
}

void CNitraDlg::addTasks(std::vector<CString> &tasks, CString szDownloadPath)
{
	m_dl.addTasks(tasks, szDownloadPath);
}

void CNitraDlg::OnRclickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UINT uiFlag;

	POINT pt, ptt;
	GetCursorPos(&pt);
	ptt = pt;

	m_taskList.ScreenToClient(&pt);

	int iIndex = m_taskList.HitTest(pt, &uiFlag);

	if(iIndex < 0) return;

	m_taskList.SetItemState(iIndex, LVIS_SELECTED, LVIS_SELECTED);

	CMenu main, *popup;
	main.LoadMenu(IDR_MENUTASK);

	popup = main.GetSubMenu(0);

	CIntraTask::_task_state state = m_dl.queue[iIndex].getState();

	if(state == CIntraTask::NOTHING || state == CIntraTask::COMPLETE) 
	{
		popup->EnableMenuItem(ID_TASK_PAUSE, MF_BYCOMMAND | MF_GRAYED);
		popup->EnableMenuItem(ID_TASK_STOP, MF_BYCOMMAND | MF_GRAYED);
	}

	if(state != CIntraTask::DOWNLOAD && state != CIntraTask::READY)
	{
		popup->EnableMenuItem(ID_TASK_PAUSE, MF_BYCOMMAND | MF_GRAYED);
		popup->EnableMenuItem(ID_TASK_STOP, MF_BYCOMMAND | MF_GRAYED);
	}

	if(state == CIntraTask::DOWNLOAD || state == CIntraTask::READY ||
		state == CIntraTask::COMPLETE) 
	{
		popup->EnableMenuItem(ID_TASK_RESUME, MF_BYCOMMAND | MF_GRAYED);
	}

	if(state == CIntraTask::COMPLETE) 
	{
		popup->EnableMenuItem(ID_TASK_OPEN, MF_BYCOMMAND | MF_GRAYED);
	}

	popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON,
		ptt.x, ptt.y, this, NULL);
}

void CNitraDlg::OnMenuTaskResume() 
{
	int iTask = GetTaskListSelectedItem();
	
	m_dl.queue[iTask].setState(CIntraTask::NOTHING);

	CWaitCursor wc;

	m_dl.startTask(iTask);
}

void CNitraDlg::OnMenuTaskDelete() 
{
	int iTask = GetTaskListSelectedItem();
	
	CWaitCursor wc;

	m_dl.deleteTask(iTask);
}

void CNitraDlg::OnMenuTaskPause() 
{
	int iTask = GetTaskListSelectedItem();

	CWaitCursor wc;
	
	m_dl.pauseTask(iTask);
}

void CNitraDlg::OnMenuTaskStop() 
{
	int iTask = GetTaskListSelectedItem();

	CWaitCursor wc;
	
	m_dl.stopTask(iTask);
}

void CNitraDlg::OnMenuTaskOpen()
{
	int iTask = GetTaskListSelectedItem();

	CWaitCursor wc;

	::ShellExecute(NULL, _T("open"), m_dl.queue[iTask].downloadPath, 
				   "", NULL, SW_SHOW);
}

void CNitraDlg::OnMenuTaskOpenFolder()
{
	int iTask = GetTaskListSelectedItem();

	CString szFolder = m_dl.queue[iTask].sourcePath;

	szFolder = szFolder.Left(szFolder.ReverseFind('\\'));

	CWaitCursor wc;

	::ShellExecute(NULL, _T("open"), szFolder, "", NULL, SW_SHOW);
}

void CNitraDlg::OnMenuTaskOpenDestFolder()
{
	int iTask = GetTaskListSelectedItem();

	CString szFolder = m_dl.queue[iTask].downloadPath;

	szFolder = szFolder.Left(szFolder.ReverseFind('\\'));

	CWaitCursor wc;

	::ShellExecute(NULL, _T("open"), szFolder, "", NULL, SW_SHOW);
}

int CNitraDlg::GetTaskListSelectedItem()
{
	POSITION pos = m_taskList.GetFirstSelectedItemPosition();

	m_taskList.RedrawWindow();
    
	return m_taskList.GetNextSelectedItem(pos);
}

void CNitraDlg::OnClose() 
{
	CWaitCursor wc;

	m_dl.stopDownload();

	m_TrayIcon.RemoveIcon();

	//   
	//
	if((m_OptionsDlg.getOptions() & IDO_SAVEPOSITION) == IDO_SAVEPOSITION)
	{
		CRect rect;	GetWindowRect(&rect);

		if(rect.left > rect.left - rect.right) {
			reg.SetUserEntry(REG_APP, REG_POSX, rect.left);
			reg.SetUserEntry(REG_APP, REG_POSY, rect.top);
			reg.SetUserEntry(REG_APP, REG_WIDTH, rect.Width());
			reg.SetUserEntry(REG_APP, REG_HEIGHT, rect.Height());
		}
	}

	//    
	//
	if((m_OptionsDlg.getOptions() & IDO_SAVEWIDTH) == IDO_SAVEWIDTH)
	{
		CString keyName;

		for(int i = 0; i < 6; i++)
		{
			keyName.Format("Column %d", i);

			reg.SetUserEntry(REG_APP, keyName, m_taskList.GetColumnWidth(i));
		}
	}

	CDialog::OnClose();
}

void CNitraDlg::saveOptions()
{

}

void CNitraDlg::loadOptions()
{
	CString text = m_OptionsDlg.getDownloadFolder();

	if(text != "") m_dl.setDownloadFolder(text);

	LONG lOptions = m_OptionsDlg.getOptions();

	if((lOptions & IDO_RECONNECT_5) == IDO_RECONNECT_5)
		m_dl.setReconnectPeriod(5);

	else if((lOptions & IDO_RECONNECT_30) == IDO_RECONNECT_30)
		m_dl.setReconnectPeriod(30);

	else if((lOptions & IDO_RECONNECT_60) == IDO_RECONNECT_60)
		m_dl.setReconnectPeriod(60);

	setupOptions();
}

void CNitraDlg::setupOptions()
{
	LONG lOptions = m_OptionsDlg.getOptions();

	if((lOptions & IDO_SPEED_KBPS) == IDO_SPEED_KBPS)
	{
		m_dl.setSpeedUnit(1);
		m_taskList.m_szSpeedFace = "Kbps";
	}
	else if((lOptions & IDO_SPEED_MBPS) == IDO_SPEED_MBPS)
	{
		m_dl.setSpeedUnit(2);
		m_taskList.m_szSpeedFace = "Mbps";
	}

	SetWindowPos((lOptions & IDO_ALWAYSONTOP) == IDO_ALWAYSONTOP ? &wndTopMost : &wndNoTopMost,
		0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
}

void CNitraDlg::OnNcPaint() 
{
	CDialog::OnNcPaint();
}

void CNitraDlg::OnOptions()
{
	COptionsDlg dlg;

	dlg.DoModal();
	
	setupOptions();

	m_taskList.RedrawItems(0, 1);
}

void CNitraDlg::OnAddNewTasks()
{
	char buffer[65535] = "\x0";

	CFileDialog dlg(TRUE, "*", "*.*",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT |
		OFN_ALLOWMULTISELECT, "All files (*.*)|*.*||", this);

	dlg.m_ofn.lpstrFile = buffer;
	dlg.m_ofn.nMaxFile = sizeof(buffer);

	if( dlg.DoModal() == IDOK ) 
	{
		POSITION pos = dlg.GetStartPosition();

		std::vector<CString> files;

		while(pos) {
			files.push_back(dlg.GetNextPathName(pos));
		}

		m_dl.addTasks(files);
	}	
}

void CNitraDlg::OnAddNewTasksFolder()
{
	char buffer[65535] = "\x0";
	static CString prevFolder = "";

	CFileDialog dlg(TRUE, "*", "*.*",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT |
		OFN_ALLOWMULTISELECT, "All files (*.*)|*.*||", this);

	dlg.m_ofn.lpstrFile = buffer;
	dlg.m_ofn.nMaxFile = sizeof(buffer);

	if( dlg.DoModal() == IDOK ) 
	{
		POSITION pos = dlg.GetStartPosition();

		std::vector<CString> files;

		while(pos) {
			files.push_back(dlg.GetNextPathName(pos));
		}

		//    
		//
		CShellOpenFolder of;

		if(of.OpenFolderDlg(prevFolder, GetSafeHwnd()))
		{
			m_dl.addTasks(files, prevFolder);
		}
	}	
}

BOOL CNitraDlg::OnToolTipText(UINT, NMHDR* pNMHDR, LRESULT* pResult)
{
	ASSERT(pNMHDR->code == TTN_NEEDTEXTA || pNMHDR->code == TTN_NEEDTEXTW);

	// allow top level routing frame to handle the message
	if (GetRoutingFrame() != NULL)
		return FALSE;

	// need to handle both ANSI and UNICODE versions of the message
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	TCHAR szFullText[256];
	CString cstTipText;
	CString cstStatusText;

	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ((UINT)(WORD)::GetDlgCtrlID((HWND)nID));
	}

	if (nID != 0) // will be zero on a separator
	{
		::LoadString(AfxGetInstanceHandle(), nID, szFullText, sizeof(szFullText));

			// this is the command id, not the button index
		AfxExtractSubString(cstTipText, szFullText, 1, '\n');
		AfxExtractSubString(cstStatusText, szFullText, 0, '\n');
	}

	// Non-UNICODE Strings only are shown in the tooltip window...
	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, cstTipText,
            (sizeof(pTTTA->szText)/sizeof(pTTTA->szText[0])));
	else
		_mbstowcsz(pTTTW->szText, cstTipText,
            (sizeof(pTTTW->szText)/sizeof(pTTTW->szText[0])));
	*pResult = 0;

	// bring the tooltip window above other popup windows
	::SetWindowPos(pNMHDR->hwndFrom, HWND_TOP, 0, 0, 0, 0,
		SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOMOVE);


	return TRUE;    // message was handled
}

void CNitraDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
}

void CNitraDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
//	if((m_OptionsDlg.getOptions() & IDO_STARTMINIMIZE) == 
//			IDO_STARTMINIMIZE && nState == 1)
//		ShowWindow(SW_HIDE);

	if((m_OptionsDlg.getOptions() & IDO_MINIMIZEINTRAY) == 
			IDO_MINIMIZEINTRAY && bMinimized)
	{
		ShowWindow(SW_HIDE);
	}

	CDialog::OnActivate(nState, pWndOther, bMinimized);
}

void CNitraDlg::OnPopupShow()
{
	ShowWindow(SW_SHOWNOACTIVATE);
}

void CNitraDlg::OnPopupAbout()
{
	CAboutDlg dlgAbout;

	dlgAbout.m_szKernel = "Downloader kernel version: " + m_dl.getKernelVersion();
	dlgAbout.DoModal();
}

void CNitraDlg::OnPopupExit()
{
	PostMessage(WM_CLOSE, 0, 0);
}

void CNitraDlg::OnWindowPosChanging(WINDOWPOS FAR* lpwndpos) 
{
	const int criticalBound = 8;

	int cxScreen = ::GetSystemMetrics(SM_CXSCREEN);
	int cyScreen = ::GetSystemMetrics(SM_CYSCREEN);

	if(lpwndpos->x < criticalBound) lpwndpos->x = 0;

	if(lpwndpos->y < criticalBound) lpwndpos->y = 0;

	if(lpwndpos->x + lpwndpos->cx > cxScreen - criticalBound) 
		lpwndpos->x = cxScreen - lpwndpos->cx;

	if(lpwndpos->y + lpwndpos->cy > cyScreen - criticalBound) 
		lpwndpos->y = cyScreen - lpwndpos->cy;
	
	CDialog::OnWindowPosChanging(lpwndpos);
}

void CNitraDlg::OnTimer(UINT nIDEvent) 
{
	if(!m_TrayIcon.SetTooltipText(DescribeState()))
	{
		m_TrayIcon.HideIcon();
		m_TrayIcon.ShowIcon();
	}

	CDialog::OnTimer(nIDEvent);
}

CString CNitraDlg::DescribeState()
{
	CString desc = TRAYTOOLTIP;
	CString row;
	float per;

	if(m_dl.queue.size() > 0) 
		desc += "\n\n";

	for(int i = 0; i < m_dl.queue.size(); i++)
	{
		per = m_dl.queue[i].offset;
		per = per / m_dl.queue[i].dwFileSize;
		per = per * 100;

		row.Format("%s - %.1f%% [%s]\n", m_dl.queue[i].displayName, per,
			m_dl.queue[i].getStateName());

		desc += row;
	}

	if(m_dl.queue.size() > 0) 
		desc = desc.Left(desc.GetLength() - 1);

	return desc;
}

void CNitraDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	lpMMI->ptMinTrackSize.x = 200;
	lpMMI->ptMinTrackSize.y = 140;

	
	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CNitraDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	HDWP hdwp = BeginDeferWindowPos(2);
	if(hdwp == NULL) return;

	DeferWindowPos(hdwp, m_taskList.GetSafeHwnd(), NULL, 0, 
		0,	cx - 15, cy - 30, SWP_NOZORDER | SWP_NOMOVE);

	DeferWindowPos(hdwp, m_wndToolBar.GetSafeHwnd(), NULL, 0, 
		0,	cx, 24, SWP_NOZORDER | SWP_NOMOVE);

	EndDeferWindowPos(hdwp);
	
}

void CAboutDlg::OnOK() 
{
	CDialog::OnOK();
}
