#if !defined(AFX_OPTIONSDLG_H__859AD62F_1451_4A22_BD2C_8ED9D811AE15__INCLUDED_)
#define AFX_OPTIONSDLG_H__859AD62F_1451_4A22_BD2C_8ED9D811AE15__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OptionsDlg.h : header file
//

#include "optionspanel.h"

#define		REG_APP			"Nitra"
#define		REG_POSX		"PositionX"
#define		REG_POSY		"PositionY"
#define		REG_WIDTH		"Width"
#define		REG_HEIGHT		"Height"
#define		REG_DOWNLOADFOLDER		"DefaultDownloadFolder"
#define		REG_OPTIONS		"OptionsFlag"

#define IDO_SAVEPOSITION	1
#define IDO_SAVEWIDTH		2
#define IDO_MINIMIZEINTRAY	4
#define IDO_SPEED_MBPS		8
#define IDO_SPEED_KBPS		16
#define IDO_RECONNECT_5		32
#define IDO_RECONNECT_30	64
#define IDO_RECONNECT_60	128
#define IDO_STARTMINIMIZE	256
#define IDO_ALWAYSONTOP		512

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog

class COptionsDlg : public CDialog
{
	LONG m_lOptions;

// Construction
public:
	CString getDownloadFolder();
	LONG getOptions();

	COptionsDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(COptionsDlg)
	enum { IDD = IDD_OPTIONS_DIALOG };
	CEdit	m_Folder;
	COptionsPanel	m_opt;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsDlg)
	protected:
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	afx_msg void OnOptionsSelChange(NMHDR *pNMHDR,LRESULT *pResult);

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COptionsDlg)
	afx_msg void OnBtnFolder();
	afx_msg void OnClose();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONSDLG_H__859AD62F_1451_4A22_BD2C_8ED9D811AE15__INCLUDED_)
